#include <ctime>
#include <cstring>
#include <iostream>
#include <conio.h>	
//include <conio.h> to use getch()

using namespace std;

#include "models.h"
//to use the implementation of the models, you have to include <conio.h>


/************************************************************************/
/************************************************************************/
void demoOfKeyboardModel()
{
		cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Test the correctness of the keyboard model implementation, and" 
		 << "Show the probabilities of touching keys for different characters " 
		 << "when mentally you are in a state of trying to type something.  " << endl
		 << "*********************************************************" << endl; 
	cout<<endl<<"Press space to continue."<<endl;		
	getch();
	char asciiMap[] = "abcdefghijklmnopqrstuvwxyz";
	for (int i=0; i< 26; i++)
	{double prSum;
	 prSum = 0;
	 cout << "Probability distribution over "
		  << "all possible resulting characters when trying to type "
		  << asciiMap[i] << endl;
	 for (int j=0; j< 26; j++)
		{	
			cout << '\t' 
				 << "Pr[Char=" << asciiMap[j] << "|State=" << asciiMap[i] << "]="
				 << prCharGivenCharOfState(asciiMap[j], asciiMap[i]) << endl;
			prSum += prCharGivenCharOfState(asciiMap[j], asciiMap[i]);
		}
	 cout << "The sum of probability distribution over "
		  << "all possible resulting characters when trying to type "
		  << asciiMap[i] 
		  << " is " 
		  << prSum  << endl << endl;

	 cout<<endl<<"Press space to continue."<<endl;		
	 getch();
	}
	cout << endl << endl ;
}



/************************************************************************/
/************************************************************************/
void demoInitialProbaility()
{
	cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Demonstrate initial probability implementation on a 5-character word." 
		 << "We use the indices 0 to 4 to refer to the states for the first 5 characters " 
		 << "in the word and index 5 to refer to the final state. " << endl
		 << "*********************************************************" << endl; 
	cout<<endl<<"Press space to continue."<<endl;		
	getch();
	int sizeOfTable = strlen("guess");
	int currentState;
	double prSum = 0;
	double initialPrTable[5];
	getPrTableForPossibleInitialStates(initialPrTable,5);
	for (currentState=0; currentState < sizeOfTable; currentState++)
		{	cout << '\t' 
				 << "Pr[InitialState=" << currentState  << "]="
				 << initialPrTable[currentState] << endl;
			prSum += initialPrTable[currentState];
		}
	 cout << "The sum of probability distribution over "
		  << "all possible initial states of a 5-character word ="
		  << prSum  << endl << endl;
	 cout<<endl<<"Press space to continue." << endl;		
	 getch();
	
}


/************************************************************************/
/************************************************************************/
void demoOfKeyboardPlusSpellingModels()
{
    for (int i=0; i<4; i++)
	{
	 cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Simulate what may be typed when we try to type the word guess for 4 times" << endl
		 << "*********************************************************" << endl;  
	 cout<<endl<<"Press space to continue."<<endl;		
	 getch();
	 char wordToType[]="guess";
	 char charsYouSee[100];
	 typeOneWord(wordToType,charsYouSee,99);
	 cout << "Word to type:\n" << wordToType << endl;
	 cout << "Chars you see:\n" << charsYouSee<< endl;
	 cout<<endl<<"Press space to continue."<<endl;		
	 getch();
	}
}


/************************************************************************/
/************************************************************************/
void demoTransitionProbability()
{
		cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Test transition probability implementation on a 5-character word." << endl
		 << "*********************************************************" << endl
		 << "Demonstrate transition probabilities from current state to the next state." 
		 << "We use the indices 0 to 4 to refer to the states for the first 5 characters " 
		 << "in the word and index 5 to refer to the final state. " << endl
		 << "*********************************************************" << endl;  
	cout<<endl<<"Press space to continue."<<endl;		
	getch();

	int sizeOfSpace = strlen("guess")+1;
	for (int currentState=0; currentState< sizeOfSpace-1; currentState++)
	{double prSum, transitionPrTable[6];
	 cout << "Probability distribution over "
		  << "all possible next states given that the current state is "
		  << currentState << endl;

	 prSum = 0;
     //nextStatePrTableGivenCurrentState(currentState,transitionPrTable,6);
	getPrTableForPossibleNextStates
	(transitionPrTable, 6, currentState);

	for (int nextState=0; nextState< sizeOfSpace; nextState++)
		{	cout << '\t' 
				 << "Pr[NextState=" << nextState << "|CurrentState=" << currentState << "]="
				 << transitionPrTable[nextState] << endl;
			prSum += transitionPrTable[nextState];
		}
	 cout << "The sum of probability distribution over "
		  << "all possible next states given that CurrentState="
		  << currentState
		  << " is " 
		  << prSum  << endl << endl;
	 cout<<endl<<"Press space to continue."<<endl;		
	 getch();
	}

}


/************************************************************************/
// Test the automatic recognition of a given series of characters
// using the set of words specified in testVocabulary.txt as vocabulary.
/************************************************************************/
void repetitiveAutomaticCorrectionOfSingleWord()
{
	cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Test the automatic recognition of a given series of characters " 
		 << "using the set of words specified in testVocabulary.txt as vocabulary." << endl
		 << "*********************************************************" << endl;  
	cout<<endl<<"Press space to continue."<<endl;		
	getch();

	int sizeOfVocabulary;  char vocabularyBuffer[1000];
	int sizeOfVocabularyBuffer = 999;
	char vocabularyFile[] = "testVocabulary.txt";
	sizeOfVocabulary = readVocabularyFileIntoCharBuffer
	(vocabularyBuffer, sizeOfVocabularyBuffer,vocabularyFile);
	cout << "The vocabulary file is " << vocabularyFile << endl;

	char * * vocabularyPointersList = new char * [sizeOfVocabulary]; 
	sizeOfVocabulary = getWordsPointersListFromCharBuffer
		(vocabularyPointersList, sizeOfVocabulary,
		 vocabularyBuffer, sizeOfVocabularyBuffer);
	cout << sizeOfVocabulary << " words in that vocabulary file" << endl<< endl;

	char noisyWordToRecognize[50]="aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa";
	char outputBuffer[100]; int bufferSize=99; int numOfLikelyWordsToSuggest=5;
	bool trace=true;

	while ( strcmp(noisyWordToRecognize,"QUIT")!=0 )
	{	cout << "Give me a series of character for correction or type QUIT to quit:";
		cin >> noisyWordToRecognize;
		cout << endl;
		recognize1NoisyWordFromVocabulary
		(	noisyWordToRecognize, 
			vocabularyPointersList, sizeOfVocabulary-1,
			outputBuffer, bufferSize, numOfLikelyWordsToSuggest,
			trace
		);
		//cout<<endl<<"Press space to continue."<<endl;		
		//getch();
	}
}



/************************************************************************/
/************************************************************************/
void generateRandomMessageOfWords()
{
	cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Test the automatic generation of corrupted words from " 
		 << "the set of words specified in testVocabulary.txt as vocabulary." 
		 << "First some words from testVocabulary.txt are randomly picked, and " 
		 << "stored in realMessage." 
		 << "For each word, we then simulate how it might be corrupted when "
		 << "we try to type it." 
		 << "The corrupted words are stored in corruptedMessage.txt." << endl
		 << "*********************************************************" << endl;  
	cout<<endl<<"Press space to continue."<<endl;		
	getch();
	typeRandomWordsFromVocabulary
	(20, "corruptedMessage.txt", "realMessage.txt", "testVocabulary.txt");
	cout<<endl<<"Press space to continue."<<endl;		
	getch();

}


/************************************************************************/
/************************************************************************/
void tryToRecoverMessageFromcorruptedMessage()
{
	cout << endl << endl 
		 << "*********************************************************" << endl
		 << "Test the recovery of a file of corrupted words from a vocabulary file." 
		 << "*********************************************************" << endl
		 << "Test the automatic recovery of corrupted words in corruptedMessage.txt" 
		 << "With the set of words in testVocabulary.txt specify as vocabulary," 
		 << "we try to recognize the corrupted words in corruptedMessage.txt one by one, and " 
		 << "for each corrupted word provide the most like 4 candidate words in testVocabulary.txt" << endl
		 << "*********************************************************" << endl;  
	cout<<endl<<"Press space to continue."<<endl;		
	getch();

	recognizeNoisyWordsInFileFromVocabulary
	("corruptedMessage.txt", "testVocabulary.txt", 
	 "recoveredTestMessage.txt", 4, true);
	
	cout<<endl<<"Press space to continue."<<endl;		
	getch();
}




/************************************************************************/
/************************************************************************/
void main()
{
	srand( (unsigned)time( NULL ) );

	demoOfKeyboardModel();

    demoOfKeyboardPlusSpellingModels();

	demoInitialProbaility();

	demoTransitionProbability();

	repetitiveAutomaticCorrectionOfSingleWord();

	generateRandomMessageOfWords();
	
	tryToRecoverMessageFromcorruptedMessage();


}

