void typeOneWord(char word[], char output[], int maxOutput);
//Simulate the combination of the spelling model and the keyboard model:
//Given a word stored in the word array, simulate what may actually
//be typed and store the result in the output array.
//maxOutput specifies the capacity limit of the output array


char typeOneChar(char charToType);
//Simulate the keyboard model:
//Given the charToTye, simulate what character may actually
//be typed and return it as the result.

double prCharGivenCharOfState(char charGenerated, char charOfTheState);
//Calculate and return the probability of charGenerated actually typed
//given charOfTheState as the underlying cognitive state. 

int take1SampleFrom1PrSpace(double prTable[], int sizeOfTable);
/************************************************************************/
//Given the probabilities (of sizeOfTable elements) stored in prTable,
//	try to randomly take a sample out of sizeOfTable elements
//	according to the probabilities (of sizeOfTable elements;
//Return the index of the non-deterministically sampled element.
/************************************************************************/


void getPrTableForPossibleInitialStates(double prTable[], int sizeOfTable);
/************************************************************************/
//Calculate for each actual cognitive state in a word of sizeOfTable characters,
//	the probability of that cognitive state being the actual first cognitive state
//	when the user types the word.
//Store these prbabilities in the prTable array.
/************************************************************************/



void getPrTableForPossibleNextStates
(double transitionPrTable[], int sizeOfTable, int currentState);
/************************************************************************/
//Calculate for each actual cognitive state in a word of sizeOfTable characters,
//	the transition probability of that cognitive state being the next cognitive state
//	given currentState as the current state.
//Store these prbabilities in the transitionPrTable[] array.
/************************************************************************/


//void nextStatePrTableGivenCurrentState
//(int currentState, double transitionPrTable[],int sizeOfSpace);
//// Redundant and removed


double prOf1CharSeriesWhenTyping1Word(char charSeries[], char word[]);
//The probability of getting a series of characters stored in charSeries 
//	(terminated with an additional NULL character in the charSeries array)
//when you want to type a word stored in the word array
//	(terminated with an additional NULL character in the word array).



void typeRandomWordsFromVocabulary
(int numWordsToType, char * corruptedMessageFile, char * realMessageFile, char * vocabularyFile, bool trace = false);
//Randomly select numWordsToType words (repetition allowed) from the file: vocabularyFile and
//	store these words as a message in the file: realMessageFile.
//Then for each of these randomly seected words above, simulate how it may be typed according to the spelling model
//	and the keyboard model and store the resulting character string in corruptedMessageFile.



int readVocabularyFileIntoCharBuffer
(char * vocabularyBuffer, int sizeOfVocabularyBuffer,
 char * vocabularyFile);
//Read in words from vocabularyFile and store each word as a contiguous series
//	of characters ended with an additional NULL character in the vocabularyBuffer. 
//The vocabularyBuffer has a capcility of sizeOfVocabularyBuffer.
//	We allow up to 99 characters per word.
//Return the total number of words read from vocabularyFile.



int getWordsPointersListFromCharBuffer
(char * * vocabularyPointersList, int sizeOfVocabularyPointersList,
 char * vocabularyBuffer, int sizeOfVocabularyBuffer);
//Parse the vocabularyBuffer of size sizeOfVocabularyBuffer, and
//	store up to sizeOfVocabularyPointersList character pointers pointing to 
//	the first sizeOfVocabularyPointersList words stored in vocabularyBuffer.
//Return the number of words you can actually find in the vocabulary buffer.



void recognize1NoisyWordFromVocabulary
(char * noisyWordToRecognize, 
 char * * vocabularyPointersList, int sizeOfVocabulary,
 char * ouputBuffer, int bufferSize, int numOfLikelyWordsToSuggest=1,
 bool trace = false);
//Recongnize the noisyWrodToRecognize, suggest up to numOfLikelyWordsToSuggest 
//	most likely words out of the sizeOfVocabulary words in the vocabulary
//	pointed to by pointers in vocabularyPointersList, and write these words to the
//	outputBuffer of size bufferSize.




void recognizeNoisyWordsInFileFromVocabulary
(char* noisyWordsFile, char * vocabularyFile, 
 char * ouputFile, int numOfLikelyWordsToSuggest=1, bool trace=false);
//Recongnize the noisyWrodToRecognize, suggest up to numOfLikelyWordsToSuggest 
//	most likely words from the vocabularyFile, and write these words to the
//	outputBuffer of size bufferSize.
//If the outputBuffer is not big enough to hold all the numOfLikelyWordsToSuggest
//words, return false; otherwise return true.
